Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Rice Pastry API
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## rice.p2p.past
Interface PastContent

All Superinterfaces:
  java.io.Serializable

All Known Subinterfaces:
  GCPastContent, RawGCPastContent, RawPastContent

All Known Implementing Classes:
  Aggregate, ContentHashPastContent, DebugContent, DistPastTestContent, JavaSerializedGCPastContent, JavaSerializedPastContent, MyPastContent, NonAggregate, PastRegrTest.NonMutableTestPastContent, PastRegrTest.NonOverwritingTestPastContent, PastRegrTest.TestPastContent, PastRegrTest.VersionedTestPastContent, RawAggregate, RawPastRegrTest.NonMutableTestPastContent, RawPastRegrTest.NonOverwritingTestPastContent, RawPastRegrTest.TestPastContent, RawPastRegrTest.VersionedTestPastContent

    public interface PastContent

extends java.io.Serializable

Version:
  $Id: PastContent.java 3613 2007-02-15 14:45:14Z jstewart $
Author:
  Alan Mislove, Ansley Post, Peter Druschel

Method Summary
`PastContent` | `checkInsert(Id id, PastContent existingContent)` Checks if a insert operation should be allowed.
`PastContentHandle` | `getHandle(Past local)` Produces a handle for this content object.
`Id` | `getId()` Returns the Id under which this object is stored in Past.
`boolean` | `isMutable()` States if this content object is mutable.

Method Detail

### checkInsert

    PastContent checkInsert(Id id,
                            PastContent existingContent)
                            throws PastException

  Checks if a insert operation should be allowed. Invoked when a Past node receives an insert request and it is a replica root for the id; invoked on the object to be inserted. This method determines the effect of an insert operation on an object that already exists: it computes the new value of the stored object, as a function of the new and the existing object.

  Parameters:
    `id` - the key identifying the object
    `newObj` - the new object to be stored
    `existingObj` - the existing object stored on this node (null if no object associated with id is stored on this node)
  Returns:
    null, if the operation is not allowed; else, the new object to be stored on the local node.
  Throws:
    `PastException`

### getHandle

    PastContentHandle getHandle(Past local)

  Produces a handle for this content object. The handle is retrieved and returned to the client as a result of the Past.lookupHandles() method.

  Parameters:
    `The` - local Past service which the content is on.
  Returns:
    the handle

### getId

    Id getId()

  Returns the Id under which this object is stored in Past.

  Returns:
    the id

### isMutable

    boolean isMutable()

  States if this content object is mutable. Mutable objects are not subject to dynamic caching in Past.

  Returns:
    true if this object is mutable, else false

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Rice Pastry API
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2001-2005 - Rice Pastry.